#!/usr/bin/env python
# -*- coding: utf-8 -*-
# ------------------------------------------------------------------------------
# glydget - an OpenGL widget toolkit
# Copyright (c) 2009 - Nicolas P. Rougier
#
# This file is part of glydget.
#
# glydget is free software: you can  redistribute it and/or modify it under the
# terms of  the GNU General  Public License as  published by the  Free Software
# Foundation, either  version 3 of the  License, or (at your  option) any later
# version.
#
# glydget is  distributed in the hope that  it will be useful,  but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
# A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy  of the GNU General Public License along with
# glydget. If not, see <http://www.gnu.org/licenses/>.
# -----------------------------------------------------------------------------

if __name__ == '__main__':
    import pyglet
    pyglet.options['debug_gl'] = False
    import pyglet.gl as gl
    import glydget
    from functools import partial

    def quit(*args):
        pyglet.app.exit()

    window = pyglet.window.Window(width=512,height=512, vsync=0)
    pyglet.clock.schedule(lambda dt: None)
    fps_display = pyglet.clock.ClockDisplay()

    a_bool  = True
    a_int   = 1
    a_float = 1.2345
    a_str   = 'Hello world !'
    variable = partial(glydget.Variable, namespace=locals())
    dialog = glydget.Window ("Variables demo",
                             [variable('a_bool'),
                              variable('a_int'),
                              variable('a_float'),
                              variable('a_str'),
                              glydget.Button('Quit', quit)])
    dialog.show()
    dialog.move(window.width//2-dialog.width//2,
                window.height//2+dialog.height//2)
    window.push_handlers(dialog)

    gl.glEnable(gl.GL_BLEND)
    @window.event
    def on_draw():
        gl.glClearColor(1,1,1,1)
        window.clear()
        dialog.batch.draw()
        fps_display.draw()
    pyglet.app.run()

    print 'a_bool :', a_bool
    print 'a_int  :', a_int
    print 'a_float:', a_float
    print 'a_str  :', a_str
