#!/usr/bin/env python
# -*- coding: utf-8 -*-
# ------------------------------------------------------------------------------
# glydget - an OpenGL widget toolkit
# Copyright (c) 2009 - Nicolas P. Rougier
#
# This file is part of glydget.
#
# glydget is free software: you can  redistribute it and/or modify it under the
# terms of  the GNU General  Public License as  published by the  Free Software
# Foundation, either  version 3 of the  License, or (at your  option) any later
# version.
#
# glydget is  distributed in the hope that  it will be useful,  but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
# A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy  of the GNU General Public License along with
# glydget. If not, see <http://www.gnu.org/licenses/>.
# -----------------------------------------------------------------------------
import pyglet
pyglet.options['debug_gl'] = False
import pyglet.gl as gl

if __name__ == '__main__':
    import glydget

    window = pyglet.window.Window(512,512,vsync=0)
    fps_display = pyglet.clock.ClockDisplay()
    pyglet.clock.schedule(lambda dt: None)
    lena = pyglet.image.load('lena.png')
    gl.glEnable(gl.GL_BLEND)
    gl.glBlendFunc(gl.GL_SRC_ALPHA, gl.GL_ONE_MINUS_SRC_ALPHA)

    
    def append_child(button):
        win.child.append(glydget.Label('New label'))

    def remove_child(button):
        win.child.remove(win.child._children[-1])

    win = glydget.Window ("Window",
                          [glydget.Button('Remove child', remove_child),
                           glydget.Button('Add a child', append_child),
                           glydget.Label('Label'),
                           glydget.Button('Click me'),
                           glydget.ToggleButton('Toggle me'),
                           glydget.Folder('Folder',
                                          glydget.VBox([glydget.HBox([glydget.Label('Value '), glydget.ScalarEntry(1)], True),
                                                        glydget.HBox([glydget.Label('Value '), glydget.ScalarEntry(10)], True),
                                        glydget.HBox([glydget.Label('Value '), glydget.ScalarEntry(100)], True)])),
                           glydget.HBox([glydget.Label('Value'), glydget.Entry('Edit me...'),],True),
                           ])
    win.show()
    win.move(2, window.height-2)
    window.push_handlers(win)


    @window.event
    def on_draw():
        gl.glClearColor(1,1,1,1)
        window.clear()
        lena.blit(0,0)
        win.batch.draw()
        fps_display.draw()
    pyglet.app.run()

